unit TheseUtils;

interface

uses
  Windows;

function ModDiv(var BaseMod: Integer; Denominator: Integer): Integer;
function MehRandNybble: Integer;
procedure Swap(var A, B: Double); overload;
function InS16(V: Double): SmallInt;

function AnsiMessageBox(hWnd: HWND; Text, Caption: AnsiString; uType: UINT): Integer;
function IntToHex(Value: Integer; Digits: Integer = 1): AnsiString;
function FloatToStr(V: Extended): AnsiString;
function ModifHex(I: Integer): AnsiString;
function Modif(Value: Double): AnsiString;





implementation

uses
  SysUtils;

function ModDiv(var BaseMod: Integer; Denominator: Integer): Integer;
begin
  Result := BaseMod div Denominator;
  BaseMod := BaseMod mod Denominator;
end;

function MehRandNybble: Integer;
begin
  if RandSeed = 0 then Randomize;
  repeat
    Result := Random($11);
  until Result < $10;
end;

procedure Swap(var A, B: Double); overload;
var
  InterBuf: Double;

begin
  InterBuf := A;
  A := B;
  B := InterBuf;
end;

function InS16(V: Double): SmallInt;
begin
  if V <= Low(Result) then
    Result := Low(Result)
  else if V >= High(Result) then
    Result := High(Result)
  else
    Result := Round(V)
  ;
end;



function AnsiMessageBox(hWnd: HWND; Text, Caption: AnsiString; uType: UINT): Integer;
begin
  Result := MessageBox(hWnd, PChar(Text), PChar(Caption), uType);
  Text := '';
  Caption := '';
end;

function IntToHex(Value: Integer; Digits: Integer = 1): string;
begin
  FmtStr(Result, '%.*x', [ Digits, Value ]);
end;

function FloatToStr(V: Extended): AnsiString;
begin
  Result := FloatToStrF(V, ffFixed, 15, 8);
end;

function ModifHex(I: Integer): AnsiString;
begin
  if I = 0 then
    Result := '0'
  else if I < 0 then
    Result := '-' + IntToHex(-I, 1)
  else
    Result := '+' + IntToHex(I, 1)
  ;
end;

function Modif(Value: Double): String;
begin
  if Value = 0 then
    Result := '0'
  else if Value < 0 then
    Result := '-' + FloatToStr(-Value)
  else
    Result := '+' + FloatToStr( Value)
  ;
end;

end.
